# -*-makefile-*-
#
# Copyright (C) 2007 by Juergen Beisert
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_BUILD_VARIOUS_KERNEL) += build_various_kernel

#
# Paths and names
#
BUILD_VARIOUS_KERNEL_VERSION	:= 0
BUILD_VARIOUS_KERNEL		:= build_various_kernel-$(BUILD_VARIOUS_KERNEL_VERSION)
BUILD_VARIOUS_KERNEL_URL	:= file/$(BUILD_VARIOUS_KERNEL).$(BUILD_VARIOUS_KERNEL_SUFFIX)
BUILD_VARIOUS_KERNEL_SOURCE	:= $(SRCDIR)/$(BUILD_VARIOUS_KERNEL).$(BUILD_VARIOUS_KERNEL_SUFFIX)
BUILD_VARIOUS_KERNEL_DIR	:= $(BUILDDIR)/$(BUILD_VARIOUS_KERNEL)

KERNELTYPE := bzImage-i386

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

build_various_kernel_get: $(STATEDIR)/build_various_kernel.get

$(STATEDIR)/build_various_kernel.get: $(build_various_kernel_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

$(BUILD_VARIOUS_KERNEL_SOURCE):
	@$(call targetinfo, $@)
#	@$(call get, BUILD_VARIOUS_KERNEL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

build_various_kernel_extract: $(STATEDIR)/build_various_kernel.extract

$(STATEDIR)/build_various_kernel.extract: $(build_various_kernel_extract_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

build_various_kernel_prepare: $(STATEDIR)/build_various_kernel.prepare

BUILD_VARIOUS_KERNEL_PATH	:= PATH=$(CROSS_PATH)

#
# autoconf
#
BUILD_VARIOUS_KERNEL_AUTOCONF := $(CROSS_AUTOCONF_USR)

$(STATEDIR)/build_various_kernel.prepare: $(build_various_kernel_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

build_various_kernel_compile: $(STATEDIR)/build_various_kernel.compile

$(STATEDIR)/build_various_kernel.compile: $(build_various_kernel_compile_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

build_various_kernel_install: $(STATEDIR)/build_various_kernel.install

$(STATEDIR)/build_various_kernel.install: $(build_various_kernel_install_deps_default)
	@$(call targetinfo, $@)
#	@$(call install, BUILD_VARIOUS_KERNEL)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

build_various_kernel_targetinstall: $(STATEDIR)/build_various_kernel.targetinstall

$(STATEDIR)/build_various_kernel.targetinstall: $(build_various_kernel_targetinstall_deps_default)
	@$(call targetinfo, $@)

ifdef PTXCONF_BUILD_FINAS
	@rm -f $(IMAGEDIR)/finas_kernel
	$(BUILD_VARIOUS_KERNEL_PATH) mkelfImage --type=$(KERNELTYPE) \
		--command-line="$(call remove_quotes,$(PTXCONF_KERNEL_BASE_LINE)) $(call remove_quotes,$(PTXCONF_BUILD_FINAS_STRING))" \
		--kernel=$(IMAGEDIR)/linuximage --output=$(IMAGEDIR)/finas_kernel
endif

ifdef PTXCONF_BUILD_MONA
	@rm -f $(IMAGEDIR)/mona_kernel
	$(BUILD_VARIOUS_KERNEL_PATH) mkelfImage --type=$(KERNELTYPE) \
		--command-line="$(call remove_quotes,$(PTXCONF_KERNEL_BASE_LINE)) $(call remove_quotes,$(PTXCONF_BUILD_MONA_STRING))" \
		--kernel=$(IMAGEDIR)/linuximage --output=$(IMAGEDIR)/mona_kernel
endif

ifdef PTXCONF_BUILD_MORGAN
	@rm -f $(IMAGEDIR)/morgan_kernel
	$(BUILD_VARIOUS_KERNEL_PATH) mkelfImage --type=$(KERNELTYPE) \
		--command-line="$(call remove_quotes,$(PTXCONF_KERNEL_BASE_LINE)) $(call remove_quotes,$(PTXCONF_BUILD_MORGAN_STRING))" \
		--kernel=$(IMAGEDIR)/linuximage --output=$(IMAGEDIR)/morgan_kernel
endif

ifdef PTXCONF_BUILD_ROLIA
	@rm -f $(IMAGEDIR)/rolia_kernel
	$(BUILD_VARIOUS_KERNEL_PATH) mkelfImage --type=$(KERNELTYPE) \
		--command-line="$(call remove_quotes,$(PTXCONF_KERNEL_BASE_LINE)) $(call remove_quotes,$(PTXCONF_BUILD_ROLIA_STRING))" \
		--kernel=$(IMAGEDIR)/linuximage --output=$(IMAGEDIR)/rolia_kernel
endif

	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

build_various_kernel_clean:
	rm -rf $(STATEDIR)/build_various_kernel.*
	rm -rf $(IMAGEDIR)/*_kernel

# vim: syntax=make
